from sanction import Client
from time import gmtime, mktime
import urllib

class Brightidea(object):

	def __init__(self, auth_endpoint=None, token_endpoint=None,
        client_id=None, client_secret=None, redirect_uri=None, host_name=None):

		self.client = Client(
			token_endpoint=token_endpoint,
			auth_endpoint=auth_endpoint,
			client_id=client_id,
			client_secret=client_secret)

		self.token_time = mktime(gmtime())
		self.client.request_token(grant_type='client_credentials')
		self.client.resource_endpoint = 'https://' + host_name + '/api3'
		self.client.expires_in = 10

	def get(self, model, id):
		return self.call_api('/'+model+'/'+id)

	def list(self, model, values=None, page=None, page_size=None):
		
		url = '/'+model
		if values:
			url += '?' + urllib.urlencode(self.encoded_dict(values))
		if page:
			if '?' in url:
				url += '&' + urllib.quote_plus(page)
			else: 
				url += '?' + urllib.quote_plus(page)
		if page_size:
			if '?' in url:
				url += '&' + urllib.quote_plus(page_size)
			else: 
				url += '?' + urllib.quote_plus(page_size)

		return self.call_api(url)

	def create(self, model, values=None):
		return self.call_api('/'+model, "POST", urllib.urlencode(self.encoded_dict(values)))

	def update(self, model, id, values=None):
		return self.call_api('/'+model+'/'+id, "PUT", urllib.urlencode(self.encoded_dict(values), True))

	def call_api(self, url, method=None, data=None):
		# Check if the token has expired
		if self.client.expires_in-100 + self.token_time <= mktime(gmtime()):
			self.client.request_token(grant_type='client_credentials')

		return self.client.request(url, method, data)

	def encoded_dict(self, in_dict):
		out_dict = {}
		for k, v in in_dict.iteritems():
			if isinstance(v, unicode):
				v = v.encode('utf8')
			elif isinstance(v, str):
				v.decode('utf8')
			out_dict[k] = v
		return out_dict
